/* objring.h - structure values for octagonal ring */

{       "Ring", "ring", /* long and short names */
        "cube",         /* long name of dual */
        36, 48, 18,     /* number of vertices, edges, and faces */
        {               /* vertices (x,y,z) */

#define Oct(R,X) DoOct(R, 2*R/5, X)
#define DoOct(R1,R2,X) \
               { X,  R1,  R2}, \
               { X,  R2,  R1}, \
               { X, -R2,  R1}, \
               { X, -R1,  R2}, \
               { X, -R1, -R2}, \
               { X, -R2, -R1}, \
               { X,  R2, -R1}, \
               { X,  R1, -R2}

               Oct( 100,   10), 
               Oct( 80,    10),
               Oct( 100,  -10), 
               Oct( 80,   -10),
#undef Oct
#undef DoOct
        },
        {       /* faces (numfaces + indexes into vertices) */
                /*  faces must be specified clockwise from the outside */

            18, 7,  6,  5,  4,  3,  2,  1,  0,  7, 
                15, 8,  9, 10, 11, 12, 13, 14, 15, 
            
            /*
            16, 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
            16, 0, 1,  2,  3,  4,  5,  6,  7,  8,  9,  10,  11, 12, 13, 14, 15,
            */ 
            
             4,  0,  1, 17, 16,
             4,  1,  2, 18, 17,
             4,  2,  3, 19, 18,
             4,  3,  4, 20, 19,
             4,  4,  5, 21, 20,
             4,  5,  6, 22, 21,
             4,  6,  7, 23, 22,
             4,  7,  0, 16, 23,
             
             4,  8, 24, 25,  9,
             4,  9, 25, 26, 10,
             4, 10, 26, 27, 11,
             4, 11, 27, 28, 12,
             4, 12, 28, 29, 13,
             4, 13, 29, 30, 14,
             4, 14, 30, 31, 15,
             4, 15, 31, 24,  8,
            
            18, 16, 17, 18, 19, 20, 21, 22, 23, 16, 
                24, 31, 30, 29, 28, 27, 26, 25, 24,
            
            /*
            16, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
            16, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16
            */
            
            
         }
},
