/*{{{  Header*/
/* Header file for compiling the PC juggling program for curses and Unix.
 * Copyright (C) 1991 John Robinson
 * Portions due to Allen Knutson [ALLENK], J. Gaudreau and 
 * Alastair Reid <areid@uk.ac.glasgow.dcs>.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 1.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
/*}}}  */

/*{{{  Misc defines*/
#define M_XOR 1
#define M_NORMAL 1

#define BLACK 0

#ifdef NOANSI
#define void
#endif	/* NOANSI */

#ifndef HAVEBOOL
typedef short boolean;
#endif	/* HAVEBOOL */

#define MAX_NUM_OPTIONS      20
#define MAX_NUM_HANDS	     10
#define BITS_PER_LONG        32

#define max(x, y) ( (x<y)?y:x )
#define min(x, y) ( (x<y)?x:y )
#define sqr(x)    ( x*x )

/*}}}  */

/*{{{  ball*/
#include "animate.h"

typedef struct ball {
    short    handfrom;
    short    handto;
    boolean  left_right;	/* left or right catch wanted */
    short    throw;		/* how far ball has to go */
    short    lateral;		/* how far ball has gone so far */
    anim_pix ap;
} ball;
 
/* 
throw == -2 => ball dropped
throw == -1 => ball in hand & lateral == time till next throw
throw > 0   => throw*2-lateral == time till next catch
*/
/*}}}  */

/*{{{  hand*/
typedef struct hand {
    ball     *ball;
    int      recoil,        /* How many ticks in recoil action */
             lateral;       /* How far through recoil */
    short    prior_throw;   /* The throw before this hand's next throw ! */
    int      dwell;         /* Dwell ratio for this hand */
    point    shoulder, elbow, wrist, o_elbow, o_wrist;
    point    catch, throw;
    point    init_catch, init_throw;
    
    anim_pix up_ap, low_ap;   /* The arm ! */
} hand;
/*}}}  */

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
